#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                        DMTrendLines&PricesUp.mq4 |
//|                                                                  |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v0.7 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " Copyright  2003, Company"
#property link      " http://www.company.com/"

#property indicator_chart_window
#property indicator_color1 Blue
#property indicator_buffers 1

//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;
double ExtHistoBuffer[];

void SetLoopCount(int loops)
{
}

void SetIndexValue(int shift, double value)
{
  ExtHistoBuffer[shift] = value;
}

bool MoveObject(string name, int type, datetime Atime, double Aprice, datetime Atime2 = 0, double Aprice2 = 0, color Acolor = CLR_NONE, int Aweight = 0, int Astyle = 0)
{
    if (ObjectFind(name) != -1)
    {
      int OType = ObjectType(name);

      if ((OType == OBJ_VLINE) ||
         (OType == OBJ_HLINE) ||
         (OType == OBJ_TRENDBYANGLE) ||
         (OType == OBJ_TEXT) ||
         (OType == OBJ_ARROW) ||
         (OType == OBJ_LABEL))
      {
        return(ObjectMove(name, 0, Atime, Aprice));
      }

      if ((OType == OBJ_GANNLINE) ||
         (OType == OBJ_GANNFAN) ||
         (OType == OBJ_GANNGRID) ||
         (OType == OBJ_FIBO) ||
         (OType == OBJ_FIBOTIMES) ||
         (OType == OBJ_FIBOFAN) ||
         (OType == OBJ_FIBOARC) ||
         (OType == OBJ_RECTANGLE) ||
         (OType == OBJ_ELLIPSE) ||
         (OType == OBJ_CYCLES) ||
         (OType == OBJ_TREND) ||
         (OType == OBJ_STDDEVCHANNEL) ||
         (OType == OBJ_REGRESSION))
      {
        return(ObjectMove(name, 0, Atime, Aprice) && ObjectMove(name, 1, Atime2, Aprice2));
      }

/*
          OBJ_CHANNEL,
          OBJ_EXPANSION,
          OBJ_FIBOCHANNEL,
          OBJ_TRIANGLE,
          OBJ_PITCHFORK
*/
    }
    else
    {
      return(ObjectCreate(name, type, 0, Atime, Aprice, Atime2, Aprice2, 0, 0) && ObjectSet(name, OBJPROP_COLOR, Acolor));
    }
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(0, ExtHistoBuffer);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int shift = 0;
double KUp = 0;
double BUp = 0;
int n = 0;
double MinPrice = 0;
double TargetPriceUp = 0;
double TrendPriceUp[2,1];
double Maximum[2,1];
double TimeofMaximum[2,1];
double shiftofMaximum[2,1];

/*[[
	Name := DMTrendLines&PricesUp
	Author := Copyright  2003, Company
	Link := http://www.company.com/
	Separate Window := No
	First Color := Blue
	First Draw Type := Line
	First Symbol := 217
	Use Second Data := No
	Second Color := Red
	Second Draw Type := Line
	Second Symbol := 218
]]*/






SetLoopCount(0);
// loop from first bar to current bar (with shift=0)
for(shift =Bars-1;shift >=1 ;shift --){ 
{

	TrendPriceUp[1,1] = TrendPriceUp[2,1];
	
	TrendPriceUp[2,1] = KUp*(shift) + BUp;
    SetIndexValue(shift, TrendPriceUp[2,1]);

    if( High[shift] > High[shift - 1] &&  High[shift] >= High[shift + 1]      //  - , 
	) {Maximum[1,1] = Maximum[2,1]; TimeofMaximum[1,1] = TimeofMaximum[2,1];                                 //  
	      shiftofMaximum[1,1] = shiftofMaximum[2,1]; 
	      shiftofMaximum[2,1] = shift;                               
	      Maximum[2,1] = High[shift]; 
	      TimeofMaximum[2,1] = Time[shift];                            
	          
          KUp = (Maximum[2,1]-Maximum[1,1])/(shiftofMaximum[2,1]-shiftofMaximum[1,1]);                        //     
          BUp = Maximum[1,1] - KUp*shiftofMaximum[1,1]; 
          
          TrendPriceUp[2,1] = KUp*(shift) + BUp; 
                   
          if( Maximum[1,1] >= Maximum[2,1]                                              //  , 
          ) {for(n =shiftofMaximum[1,1];n >=shiftofMaximum[2,1] ;n --){                       //    , 
                   {                                                          //   
                     TrendPriceUp[2,1] = KUp*(n) + BUp; 
                     SetIndexValue(n, TrendPriceUp[2,1]);                                
                   }
                   } 
                                                                                                                 //  
                MoveObject("UpTrend", OBJ_TREND, TimeofMaximum[1,1], Maximum[1,1], TimeofMaximum[2,1], Maximum[2,1], Blue, 1, STYLE_SOLID);  //
               }
         }
    
	if( Close[shift] > TrendPriceUp[2,1] && Close[shift+1] <= TrendPriceUp[1,1]   //   ,
	&& TrendPriceUp[1,1] >= TrendPriceUp[2,1]                                    //  .
	) {MinPrice = Low[Lowest(NULL, 0, MODE_LOW, shiftofMaximum[1,1], shiftofMaximum[1,1] - shift)];                                       //  
	      TargetPriceUp = (TrendPriceUp[2,1] - MinPrice) + TrendPriceUp[2,1];
	      
	      MoveObject("TargetPriceUp"+MathMod(shift,1), OBJ_HLINE, TimeofMaximum[1,1], TargetPriceUp, TimeofMaximum[2,1], TargetPriceUp, Blue, 1, STYLE_DOT);
	          
         }
}
}   return(0);
}